{ ****************************************************************** }
{                                                                    }
{   VCL component TKZTimeCounter                                     }
{                                                                    }
{   AKZ Time Counter                                                 }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\compon~1\akztim~1\kztcount.cd      }
{   on 20 July 1999 at 20:56                                         }
{                                                                    }
{   Copyright  1999 by Kire Zvezdakoski                             }
{                                                                    }
{ ****************************************************************** }

unit KZTCount;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Extctrls;

type
  TKZTimeCounter = class(TTimer)
    private
      { Private fields of TKZTimeCounter }
        FCounting : Boolean;
        FElapsed : String;
        FStartTime : TDateTime;
        TempTime : TDateTime;

      { Private methods of TKZTimeCounter }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        function GetCounting : Boolean;
        procedure SetCounting(Value : Boolean);
        function GetElapsed : String;
        procedure SetElapsed(Value : String);

    protected
      { Protected fields of TKZTimeCounter }
        property StartTime : TDateTime read FStartTime write FStartTime;

      { Protected methods of TKZTimeCounter }
        procedure Loaded; override;

    public
      { Public fields and properties of TKZTimeCounter }

      { Public methods of TKZTimeCounter }
        procedure Continue;
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        procedure Reset;
        procedure Stop;

    published
      { Published properties of TKZTimeCounter }
        property Counting : Boolean read GetCounting write SetCounting;
        property Elapsed : String read GetElapsed write SetElapsed;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TKZTimeCounter with KireZ as its
       default page on the Delphi component palette }
     RegisterComponents('KireZ', [TKZTimeCounter]);
end;

{ Method to set variable and property values and create objects }
procedure TKZTimeCounter.AutoInitialize;
begin
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TKZTimeCounter.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

function TKZTimeCounter.GetCounting : Boolean;
begin
     Result := FCounting;
end;

procedure TKZTimeCounter.SetCounting(Value : Boolean);
begin
     if FCounting and (not Value)
        then TempTime:=StrToTime(Elapsed);
     if (not FCounting) and Value
        then StartTime:=Now-TempTime;
     FCounting := Value;
end;

function TKZTimeCounter.GetElapsed : String;
begin
     If Counting
        then Result := TimeToStr(Now-StartTime)
        else Result := TimeToStr(TempTime);
end;

procedure TKZTimeCounter.SetElapsed(Value : String);
begin
     FElapsed := Value;
end;

procedure TKZTimeCounter.Continue;
begin
     Counting:=True;
end;

constructor TKZTimeCounter.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;

     { Code to perform other tasks when the component is created }
     StartTime:=Now;
     Elapsed:=timetostr(Now-Now);
     Counting:=True;
end;

destructor TKZTimeCounter.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TKZTimeCounter.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

procedure TKZTimeCounter.Reset;
begin
     StartTime:=Now;
     TempTime:=Now-Now;
end;

procedure TKZTimeCounter.Stop;
begin
     Counting:=False;
end;


end.
